#include <stdio.h>
#include <err.h>

FILE *fopenz(const char *name, const char *mode);
FILE *fgunzip(FILE *f);

int main(int argc, char *argv[])
{
	int i;

	if (argc < 2)
		return 1;

	for (i = 1; i < argc; i++) {
		char *arg = argv[i];
		FILE *f;
#if 1
		if (arg[0]=='-' && arg[1]==0)
			f = stdin;
		else {
			f = fopen(arg, "rb");
			if (!f)
				errx(1, "%s: error (%s)", "fopen", arg);
		}
		f = fgunzip(f);
		if (!f)
			errx(1, "%s: error (%s)", "fgunzip", arg);
#else
		f = fopenz(arg, "rb");
		if (!f)
			errx(1, "%s: error (%s)", "fopenz", arg);
#endif
		for (;;) {
			char buf[256];
			int n;
			n = fread(buf, 1, sizeof buf, f);
			if (ferror(f))
				warnx("error (%s)", arg);
			if (!n)
				break;
			(void) fwrite(buf, 1, n, stdout);
			if (feof(f))
				break;
		}
		fclose(f);
	}
	return 0;
}
